FriendlistHandler = { };


-- FriendlistData = { };

-- Constant variables
-- FriendlistData.FL_TYPE = "char";
-- FriendlistData.FL_TYPE = "guild";
-- FriendlistData.FL_FRIENDSTATE_ENEMY = -10;
-- FriendlistData.FL_FRIENDSTATE_KNOWN = 0;
-- FriendlistData.FL_FRIENDSTATE_FRIEND = 10;

function FriendlistHandler:CreateEntry(unitID)
    if ( FriendlistData == nil ) then
        FriendlistData = {};
    end
    if ( FriendlistData.Friends == nil ) then
        FriendlistData.Friends = {};
    end
    if ( FriendlistData.Friends[unitID] == nil ) then
        FriendlistData.Friends[unitID] = {};
    end
end

function FriendlistHandler:ExistsEntry( unitID )    
    if ( FriendlistData.Friends[unitID] ~= nil ) then
        return true;
    else
        return false;
    end
end

--[[ local bool = FriendlistHandler:UpdateInfo( field, value, unitID, type )
    Adds/Updates a friendlist entry
    Currently used fields:
        type, class, surname, name, altName, race, title, guild, notes, level, friendstate, rank
        "index" is updated automatically by the friendlist
    Returns true if successful, else false (never nil)
]]--
function FriendlistHandler:UpdateInfo( field, value, unitID, type )
    if ( field == nil or strtrim(field) == "" ) then
        return false;
    end
    
    if ( value == nil ) then
        return false;
    end
    self:CreateEntry(unitID);
    
    local entry = FriendlistData.Friends[unitID];
    if ( type ~= nil and type == "integer" ) then
        entry[field] = tonumber(value) or 0;    
    elseif ( type ~= nil and type == "string" ) then
        entry[field] = tostring(value) or "";
    -- elseif ( type ~= nil and type == "bool" ) then
        -- if ( value == true ) then
            -- entry[field] = true;
        -- else
            -- entry[field] = false;
        -- end
    else
        if ( field == "type" or field == "class" or field == "race" 
                or field == "surname" or field == "name" or field == "altName" or field == "title" 
                or field == "guild" or field == "notes" or field == "rank" 
                ) then
            entry[field] = value or "";
        elseif ( field == "level" or field == "friendstate" ) then
            entry[field] = tonumber(value) or 0;
        end
    end
    
    return true;
end

--[[ local tableInfo = FriendlistHandler:GetInfo( unitID, field, lookAll ) 
    Returns the requested field of unitID from your friendlist
    TODO If field is not set, it will look in the FlagList (lookAll = true)
]]-- 
function FriendlistHandler:GetInfo( field, unitID, lookAll )    
    if ( self:ExistsEntry(unitID) and FriendlistData.Friends[unitID][field] ~= nil ) then
        return FriendlistData.Friends[unitID][field];
    else
        return "";
    end
end

function FriendlistHandler:PurgeAllFriends()
    FriendlistData = nil;
end

--[[ local numFriends, typeChar, typeNPC, typeGuild, stateFriend, stateNeutral, stateEnemy = FriendlistHandler:GetStats( show ) 
    Returns the number of entries matching a specific type or state
    - show: if true, this method prints the statistic directly
    - Returns integer values of
        numFriends overall entries n your friendlist
        number of entries with the type character, npc or guild in your friendlist
        number of entries with the state friend, neutral and enemy
]]--
function FriendlistHandler:GetStats( show )
    local numFriends, typeChar, typeNPC, typeGuild = 0, 0, 0, 0;
    local stateFriend, stateNeutral, stateEnemy = 0, 0, 0;
    
    for entry, t in pairs(FriendlistData.Friends) do
        if ( t.type == "char" ) then
            typeChar = typeChar + 1;
        elseif ( t.type == "npc" ) then
            typeNPC = typeNPC + 1;
        elseif ( t.type == "npc" ) then
            typeGuild = typeGuild + 1;
        end
        
        if ( t.friendstate > 0 ) then
            stateFriend = stateFriend + 1;
        elseif ( t.friendstate == 0 ) then
            stateNeutral = stateNeutral + 1;
        elseif ( t.friendstate < 0 ) then
            stateEnemy = stateEnemy + 1;
        end
        
        numFriends = numFriends + 1;
    end
    
    if ( show ) then
        print("<FlagRSP Friendlist> Friendlist statistics:");
        print("<FlagRSP Friendlist>    Friends: " .. numFriends);
        print("<FlagRSP Friendlist>       Chars: " .. typeChar);
        print("<FlagRSP Friendlist>       NPC: " .. typeNPC);
        print("<FlagRSP Friendlist>       Guilds: " .. typeGuild);
        print("<FlagRSP Friendlist>    Friendstate:");
        print("<FlagRSP Friendlist>       Friend: " .. stateFriend);
        print("<FlagRSP Friendlist>       Neutral: " .. stateNeutral);
        print("<FlagRSP Friendlist>       Enemy: " .. stateEnemy);
    end
    
    return numFriends, typeChar, typeNPC, typeGuild, stateFriend, stateNeutral, stateEnemy;
end

